<%

'   This file is provided under the terms of the BrowserHawk End User License Agreement (EULA).
'   Copyright (c) 2005 cyScape, Inc. All rights reserved.

'   One of the most challenging aspects of deploying Java applets is guaranteeing that your
'   visitor's browser has Java installed, enabled, and of a particular version and vendor
'   that are known to work with your applet. BrowserHawk makes this process easy by enabling
'   you to detect, before sending your applet to the client, what the client's capabilities
'   and settings are. 

'   Unfortunately Java detection isn't as easy as a simple on/off switch because of the various
'   settings and variables involved. This sample therefore is designed to walk you through the
'   process and explain how to make the most of BrowserHawk when detecting your visitor's Java
'   capabilities within their browser.

'   This sample tests the various properties involved in sniffing Java, and based on the returned
'   values, reports the client's Java capabilities. You should feel free to use this sample as
'   the basis for how you sniff Java in your own application.


  set bh = Server.CreateObject("cyscape.browserObj")

' Display a friendly error message is the edition of BrowserHawk being used is not sufficient to run this sample.
' You should not include this check in your BrowserHawk code.
  DisplayErrorIfWrongEdition "Ent"


  bh.SetExtProperties "JavaScriptEnabled, JavaEnabled, Plugin_JavaVer, JavaVendor, JavaVersion, MSJVMBuild"
  bh.GetExtPropertiesEx 0, "", "Please wait...", "Please wait a few seconds while we check your browser..."

%>

<html>
<head><title>BrowserHawk Java Test Page</title></head>

<body bgcolor=white>
<font face="helvetica">

<h2>BrowserHawk Java Test Page</h2>
Java test results as detected by <a href="http://www.cyscape.com">BrowserHawk</a>:<br>


<% 

 'Initialize this warning message in case we need it later
 warningNotice = "Note for the developer: It's also possible that this condition is occurring"
 warningNotice = warningNotice & " because the JVMDetector.class file is not being found."
 warningNotice = warningNotice & " This .class file is distributed with the BrowserHawk files"
 warningNotice = warningNotice & " and should be placed into the same diretory where your web script"
 warningNotice = warningNotice & " is running from. Or, you can place it into another web directory"
 warningNotice = warningNotice & " and use BrowserHawk's JVMCodeBase to tell BH what the path to this"
 warningNotice = warningNotice & " web directory is. The web server's access logs can reveal if"
 warningNotice = warningNotice & " the file is being found and downloaded."

 browser = bh.Browser
 if (browser <> "IE" AND browser <> "Mozilla" AND browser <> "Netscape" AND browser <> "Firefox" AND browser <> "Opera" AND browser <> "Safari") then %>
  <big>No extended information is available.  Only Netscape,
  Mozilla, Firefox, IE, Opera, Safari and AOL Explorer clients are supported.</big>

<%
 elseif (bh.JavaScriptEnabled = false) then %>
  <big>No Java detection information is available.  This client has
  JavaScript disabled.</big>

<%
 elseif (supportsJavaCheck() = False) then %>
  <big>No Java detection is available.<br>For Java detection your browser has
  to be IE Windows 3+ (except exactly 4.00), Mozilla, Firefox, Safari 1.2+,
  Netscape 4.0+, or AOL Explorer.</big>

<%
 else
%>

   <br>
   <table>
   <tr><th align="left">Property</th><th>Value</th></tr>
   <tr><td width="150">JavaEnabled</font></td>
       <td><%= bh.JavaEnabled %></td></tr>
   <tr><td width="150">Plugin_JavaVer</font></td>
       <td><%= bh.Plugin_JavaVer %></td></tr>
   <tr><td width="150">JavaVersion</font></td>
       <td><%= bh.JavaVersion %></td></tr>
   <tr><td width="150">JavaVendor</font></td>
       <td><%= bh.JavaVendor %></td></tr>
   <tr><td width="150">MSJVMBuild</font></td>
       <td><%= bh.MSJVMBuild %></td></tr>
   </table>

   <br>
   <b>Conclusion:</b>
   <p>

  <%
    javaVendor = bh.JavaVendor
    javaVersion = bh.JavaVersion
    pluginJavaVer = bh.Plugin_JavaVer
    msjvmBuild = bh.MSJVMBuild

    ' Java disabled and non-empty version is a strong indication Java's disabled
    if bh.JavaEnabled = False AND pluginJavaVer <> "" then
  %>
      JavaEnabled returned false while Plugin_JavaVer detection returned a legitimate
      value.<br>This indicates you have the Java Plugin <%= pluginJavaVer %> installed
      but it's currently disabled.

  <% 
    elseif bh.JavaEnabled = False AND msjvmBuild <> "" then
  %>
      JavaEnabled returned false while MSJVMBuild detection returned a legitimate
      value.<br>This indicates you have the the MSJVM Build <%= msjvmBuild %> installed
      but it's currently disabled.

  <%
    elseif javaVersion = "-3" then
  %>
      JavaVersion returned -3. This indicates you don't have the Java Plugin
      installed and configured to run applets.

  <% 
    elseif bh.JavaEnabled = False then 'implicitly pluginJavaVer and msjvmBuild are empty
  %>
      JavaEnabled returned false and Plugin_JavaVer/MSJVMBuild detection returned no legitimate
      value.<br>This indicates you probably have no Java installed.

  <%
    elseif javaVersion = "-1" then
  %>
      JavaEnabled returned true while JavaVersion returned -1.<br>This indicates you
      most likely have a very old JVM which can't be accessed from JavaScript.<P>
      <% Response.Write warningNotice %>
  <% 
    elseif javaVersion = "-2" AND pluginJavaVer <> "" then
  %>
      JavaEnabled returned true, JavaVersion returned -2, and Plugin_JavaVer
      detection returned a legitimate value.<br>This indicates you have the Java Plugin
      <%= pluginJavaVer %> installed but scripting of applets is explicitly disabled
      so it's not possible to confirm the behavior of an applet.<P>
      <% Response.Write warningNotice %>
  <%
    elseif javaVersion = "-2" AND msjvmBuild <> "" then
  %>
      JavaEnabled returned true, JavaVersion returned -2, and MSJVMBuild
      detection returned a legitimate value.<br>This indicates you have the MSJVM Build
      <%= msjvmBuild %> installed but scripting of applets is explicitly disabled
      so it's not possible to confirm the behavior of an applet.<P>
      <% Response.Write warningNotice %>
  <%
    elseif javaVersion = "-2" then 'implicitly pluginJavaVer and msjvmBuild are empty
  %>
      JavaEnabled returned true, JavaVersion returned -2, and Plugin_JavaVer/MSJVMBuild
      detection returned no legitimate value.<br>This indicates you don't have any
      Java installed.<P>
      <% Response.Write warningNotice %>
  <%
    elseif javaVersion <> "" then 'javaVendor exists if javaVersion exists
  %>
      JavaVersion and JavaVendor indicate you have Java <%= javaVersion %> from <%= javaVendor %>
      ready to run applets under <%= bh.Browser %>&nbsp;<%= bh.Fullversion %>
      on <%= bh.Platform %>.
      <%
       java3 = left(javaVersion, 3)
       plugin3 = left(pluginJavaVer, 3)
       if (java3 <> plugin3 AND plugin3 <> "") then
            Response.Write "<br>You also have the Java Plugin version " & pluginJavaVer & " at your disposal." & java3 & "|" & plug3
       end if
      %>
  <%
    end if

end if
%>
<P>
<HR>
<P>

<b><a href="java.asp.txt">View source code (classic ASP) for this sample</a></b> (source available in <i>\Program Files\cyScape\BrowserHawk\Samples\ASP</i>)<P>
<b><a href="java.asp">Retry this test</a></b><P>
<b><a href="bh_index.asp">Return to list of other ASP samples</a></b><P>
<b><a href="..\index.htm">Return to BrowserHawk Welcome Page</a></b><P>
<b><a href="http://www.cyscape.com/order/">BrowserHawk Pricing and Ordering</a></b><P>
<b><a href="http://www.cyscape.com/">cyScape home page</a></b><P>
</font>
</body>
</html>

<%
function supportsJavaCheck()

    browser = bh.Browser
    version = bh.Version
    platform = bh.Platform

    if browser = "Mozilla" OR browser = "Firefox" then
       supportsJavaCheck = true
       exit function
    end if

    if browser = "Safari" AND version >= 1.2 then
       supportsJavaCheck = true
       exit function
    end if

    if browser = "Netscape" AND version >= 4 then
       supportsJavaCheck = true
       exit function
    end if

    if browser = "Opera" AND version >= 7 then
       supportsJavaCheck = true
       exit function
    end if

    if browser = "IE" AND left(platform, 3) = "Win" AND version >= 3 AND version <> 4.0 then
       supportsJavaCheck = true
       exit function
    end if

    supportsJavaCheck = false

end function
%>

<% sub DisplayErrorIfWrongEdition(requires) %>

<%

  errMsg = ""
  if requires = "Ent" AND Instr(bh.DLLVersion, "Ent") <= 0 then
     errMsg = "This sample requires the Enterprise Edition of BrowserHawk."
  elseif requires = "Pro" AND Instr(bh.DLLVersion, "Pro") <= 0 AND Instr(bh.DLLVersion, "Ent") <= 0 then
     errMsg = "This sample requires the Professional or Enterprise Edition of BrowserHawk."
  end if

  if errMsg <> "" then
     errMsg = errMsg & " You are using BrowserHawk " & bh.DLLVersion
  %>
    <font color="red"><% =errMsg %><br>
    <a href="http://www.cyscape.com/order/">Click here for upgrade information</a>.
  <%
     Response.End
  end if
  %>
<% end sub %>