<%@ Page language="c#"%>
<%@ Import Namespace="cyScape.BrowserHawk" %>

<%

//   This file is provided under the terms of the BrowserHawk license
//   agreement.  Copyright (c) 2005 cyScape, Inc. All rights reserved.

//   One of the most challenging aspects of deploying Java applets is guaranteeing that your
//   visitor's browser has Java installed, enabled, and of a particular version and vendor
//   that are known to work with your applet. BrowserHawk makes this process easy by enabling
//   you to detect, before sending your applet to the client, what the client's capabilities
//   and settings are. 

//   Unfortunately Java detection isn't as easy as a simple on/off switch because of the various
//   settings and variables involved. This sample therefore is designed to walk you through the
//   process and explain how to make the most of BrowserHawk when detecting your visitor's Java
//   capabilities within their browser.

//   This sample tests the various properties involved in sniffing Java, and based on the returned
//   values, reports the client's Java capabilities. You should feel free to use this sample as
//   the basis for how you sniff Java in your own application.


  // Display a friendly error message if the edition of BrowserHawk being used is not sufficient to run this sample.
  // You should not include this check in your BrowserHawk code.
  DisplayErrorIfWrongEdition("Ent", BrowserObj.BrowserHawkVersion);

  ExtendedOptions options = new ExtendedOptions();
  options.AddProperties("JavaScriptEnabled, JavaEnabled, Plugin_JavaVer, JavaVendor, JavaVersion, MSJVMBuild");
  options.PageMessage = "Please wait a few seconds while we check your browser...";

  BrowserObj info = BrowserObj.GetBrowser();
  ExtendedBrowserObj einfo = BrowserObj.GetExtendedBrowser(options);

%>

<html>
<head><title>BrowserHawk Java Test Page (C#)</title></head>

<body bgcolor=white>
<font face="helvetica">

<h2>BrowserHawk Java Test Page (C#)</h2>
Java test results as detected by <a href="http://www.cyscape.com">BrowserHawk</a>:<br>


<% 
 // The returned value is the UNSUPPORTED constant if the browser isn't
 // Netscape, Mozilla, Firefox, IE, Opera, Safari or AOL Explorer.

 // Initialize this warning message in case we need it later
 String warningNotice = "Note for the developer: It's also possible that this condition is occurring" +
    " because the JVMDetector.class file is not being found. This .class file is distributed with" +
    " the BrowserHawk files and should be placed into the same diretory where your web script" +
    " is running from. Or, you can place it into another web directory and use BrowserHawk's" +
    " JVMCodeBase to tell BH what the path to this web directory is. The web server's access" +
    " logs can reveal if the file is being found and downloaded.";


if (einfo == ExtendedBrowserObj.UNSUPPORTED) { %>
  <big>No extended information is available.  Only Netscape,
  Mozilla, Firefox, IE, Opera, and Safari clients are supported.</big>

<% } else if (einfo.JavaScriptEnabled == false) { %>
  <big>No Java detection information is available.  This client has
  JavaScript disabled.</big>

<% } else if (!supportsJavaCheck(info)) { %>
  <big>No Java detection is available.<br>For Java detection your browser has
  to be IE Windows 3+ (except exactly 4.00), Mozilla, Firefox, Safari 1.2+, Opera 7+, 
  Netscape 4.0+, or AOL Explorer.</big>

<% } else { %>

<br>

<table>
<tr><th align="left">Property</th><th>Value</th></tr>
<tr><td width="150">JavaEnabled</font></td>
    <td><%= einfo.JavaEnabled.ToString() %></td></tr>
<tr><td width="150">Plugin_JavaVer</font></td>
    <td><%= einfo.Plugin_JavaVer.ToString() %></td></tr>
<tr><td width="150">JavaVersion</font></td>
    <td><%= einfo.JavaVersion %></td></tr>
<tr><td width="150">JavaVendor</font></td>
    <td><%= einfo.JavaVendor %></td></tr>
<tr><td width="150">MSJVMBuild</font></td>
    <td><%= einfo.MSJVMBuild %></td></tr>
</table>

<br>
<b>Conclusion:</b>
<p>

  <%
    String javaVendor = einfo.JavaVendor;
    String javaVersion = einfo.JavaVersion;
    String pluginJavaVer = einfo.Plugin_JavaVer;
    String msjvmBuild = einfo.MSJVMBuild;
    if (pluginJavaVer == "") pluginJavaVer = null;
    if (msjvmBuild == "") msjvmBuild = null;

    // Java disabled and non-empty version is a strong indication Java's disabled
    if (!einfo.JavaEnabled && pluginJavaVer != null) {
  %>
      JavaEnabled returned false while Plugin_JavaVer detection returned a legitimate
      value.<br>This indicates you have the Java Plugin <%= pluginJavaVer %> installed
      but it's currently disabled.

  <% } else if (!einfo.JavaEnabled && msjvmBuild != null) { %>
      JavaEnabled returned false while MSJVMBuild detection returned a legitimate
      value.<br>This indicates you have the the MSJVM Build <%= msjvmBuild %> installed
      but it's currently disabled.

  <% } else if (javaVersion == "-3") { %>
      JavaVersion returned -3. This indicates you don't have the Java Plugin
      installed and configured to run applets.

  <% } else if (!einfo.JavaEnabled /* implicitly pluginJavaVer and msjvmBuild are null */) { %>
      JavaEnabled returned false and Plugin_JavaVer/MSJVMBuild detection returned no legitimate
      value.<br>This indicates you probably have no Java installed.

  <% } else if (javaVersion == "-1") { %>
      JavaEnabled returned true while JavaVersion returned -1.<br>This indicates you
      most likely have a very old JVM which can't be accessed from JavaScript.<P>
      <% = warningNotice %>

  <% } else if (javaVersion == "-2" && pluginJavaVer != null) { %>
      JavaEnabled returned true, JavaVersion returned -2, and Plugin_JavaVer
      detection returned a legitimate value.<br>This indicates you have the Java Plugin
      <%= pluginJavaVer %> installed but scripting of applets is explicitly disabled
      so it's not possible to confirm the behavior of an applet.<P>
      <% = warningNotice %>

  <% } else if (javaVersion == "-2" && msjvmBuild != null) { %>
      JavaEnabled returned true, JavaVersion returned -2, and MSJVMBuild
      detection returned a legitimate value.<br>This indicates you have the MSJVM Build
      <%= msjvmBuild %> installed but scripting of applets is explicitly disabled
      so it's not possible to confirm the behavior of an applet.<P>
      <% = warningNotice %>

  <% } else if (javaVersion == "-2" /* implicitly pluginJavaVer and msjvmBuild are null */) { %>
      JavaEnabled returned true, JavaVersion returned -2, and Plugin_JavaVer/MSJVMBuild
      detection returned no legitimate value.<br>This indicates you don't have any
      Java installed.<P>
      <% = warningNotice %>

   <% } else if (javaVersion != null && javaVersion != "") /* javaVendor exists if javaVersion exists */ { %>
      JavaVersion and JavaVendor indicate you have Java <%= javaVersion %> from <%= javaVendor %>
      ready to run applets under <%= info.Browser %> <%= info.Fullversion.ToString() %>
      on <%= info.Platform %>.
      <%
        try {
          // If the first 3 chars don't match between javaVersion and pluginJavaVer,
          // add a note about what plugin might be available.
          String java3 = javaVersion.Substring(0, 3);
          String plugin3 = pluginJavaVer.Substring(0, 3);
          if (java3 != plugin3) {
            Response.Write("<br>You also hava the Java Plugin version " + pluginJavaVer + " at your disposal.");
          }
        }
        catch (Exception e) { /* One of the substrings failed. */ }
      %>
  <% } %>

<% } %>


<HR>

<P>
<b><a href="java.aspx.txt">View source code (C#) for this sample</a></b> (source available in <i>\Program Files\cyScape\BrowserHawk\Samples\dotnet\csharp</i>)<P>
<b><a href="java.aspx">Retry this test</a></b><P>
<b><a href="..\bh_index.aspx">Return to list of other .NET samples</a></b><P>
<b><a href="..\..\index.htm">Return to BrowserHawk Welcome Page</a></b><P>
<b><a href="http://www.cyscape.com/order/">BrowserHawk Pricing and Ordering</a></b><P>
<b><a href="http://www.cyscape.com/">cyScape home page</a></b><P>
</font>
</body>
</html>

<script runat="server" language="C#">
  private bool supportsJavaCheck(BrowserObj info) {

    String browser = info.Browser;
    double version = info.Version;
    String platform = info.Platform;

    if (browser == "Moziila" || browser == "Firefox") {
      return true;
    }

    if (browser == "Safari" && version >= 1.2) {
      return true;
    }

    if (browser == "Netscape" && version >= 4) {
      return true;
    }


    if (browser == "Opera" && version >= 7) {
      return true;
    }

    if (browser == "IE" && platform.Substring(0,3) == "Win" && version >= 3 && version != 4.0) {
      return true;
    }

    return false;

  }
</script>

<script runat="server" language="C#">
  private void DisplayErrorIfWrongEdition(string editionRequired, string editionInUse) {

    string errMsg = "";
    if (editionRequired == "Ent" && editionInUse.IndexOf("Ent") < 0) {
       errMsg = "This sample requires the Enterprise Edition of BrowserHawk.";
    }
    else if (editionRequired == "Pro" && editionInUse.IndexOf("Pro") < 0 &&  editionInUse.IndexOf("Ent") < 0) {
       errMsg = "This sample requires the Professional or Enterprise Edition of BrowserHawk.";
    }

    if (errMsg != "") {
       errMsg = errMsg + " You are using BrowserHawk " + editionInUse;
       Response.Write("<font color=\"red\">" + errMsg + "<br>");
       Response.Write("<a href=\"http://www.cyscape.com/order/\">Click here for upgrade information</a>.");
       Response.End();
    }
  }
</script>
